# coding: utf-8
from __future__ import unicode_literals
import uno
from scriptforge import CreateScriptService

def start(*args):
    #recalc_subform(e)
    pass

def msgbox(str):
    bas = CreateScriptService("Basic")
    bas.MsgBox(str)
    bas.Dispose()

def recalc_subform(e=None):
    
    total_expenses = 0 # 総費用

    oDoc = XSCRIPTCONTEXT.getDocument()
    oForm = oDoc.DrawPage.Forms.getByName("フォーム")  # メインフォームの名前を指定

    # サブフォームを取得
    oSubForm = oForm.getByName("サブフォーム")  # サブフォームの名前を指定
    
    # データベースと接続
        # データベース接続を取得
    connection = oForm.ActiveConnection

    # SQLステートメントを作成
    statement = connection.createStatement()
    
    # 行セットのインターフェースを取得
    rowset = oSubForm.queryInterface(uno.getTypeByName("com.sun.star.sdbc.XRowSet"))

    # 行の更新を開始
    rowset.first()  # 最初の行に移動
    while True:
        try:
            # 各列の値を設定
            columns = rowset.getColumns()
            if columns:
                # 商品_id を取得
                product_id = columns.getByIndex(1).Value
                
                # 商品テーブルからデータを取得するSQLクエリ
                sql = f"SELECT 商品_単価 FROM 商品_テーブル WHERE 商品_id = {product_id}"
                unit_price_set = statement.executeQuery(sql)
                while unit_price_set.next():
                    unit_price = unit_price_set.getInt(1)

                # 2番目の列の値を取得
                quantity = columns.getByIndex(2).Value

                # 3番目の列に購入額を設定
                total_cost = unit_price * quantity
                total_expenses += total_cost
                columns.getByIndex(3).updateInt(total_cost)
                
                
                rowset.updateRow()  # 行を更新して反映させる

            # 次の行に移動
            if not rowset.next():
                break
        except Exception as e:
            print("エラー:", e)
            break

    # 更新後にリロードを行う
    oSubForm.reload()

    # サブフォームの合計値を設定（通貨フィールドなどがある場合）
    try:
        oSum = oForm.getByName("通貨フィールド_合計")
        oSum.Value = total_expenses
        
    except Exception as e:
        print("通貨フィールドの設定エラー:", e)

